Subject: RE: Comments on draft-ietf-pkix-rsa-pkalgs-00.txt

From: "Jim Schaad" <[email-masked]>
Date: Sun, 2 Mar 2003 22:43:37 -0800

Russ,

As an implementer, I think of dealing not only with the parameters but
the "data" value associated with the OID as being dependent on the OID.
This means that the following items are indexed on the OID.  The
parameters structure, the public key encoding and the signature value
encoding.  In the case of RSA the signature value encoding is really
simple - i.e. just the bytes - but for some signature algorithms this is
not true.  The fewer tables that I have to do lookups on the easer it is
to write general purpose code.  I would be perfectly happen to assign a
different OID for each different way that the encodings and mathematics
are done.  

A different question is whether the parameters should be different
between the different locations.  I agree that there should be a
restriction on only using PSS with a signature key, however I think
there is an interesting question about the requirement for different
certificates to be assigned if you want to use both SHA-256 and SHA-512
with the PSS key depending on the question of necessary duration of the
signature.

jim

> -----Original Message-----
> From: Russ Housley [mailto:[email-masked]] 
> Sent: Monday, February 24, 2003 1:28 PM
> To: [email-masked]; [email-masked]
> Cc: [email-masked]
> Subject: RE: Comments on draft-ietf-pkix-rsa-pkalgs-00.txt
> 
> 
> Burt & Jim:
> 
> Clearly there are some choices.  I believe that use of the 
> same object 
> identifier is the best we can do given the current state of 
> the world.  The 
> solution that we devise needs to be backward compatible.  I 
> do not think 
> that assigning two OIDs for each possible use of an RSA or 
> Elliptic Curve 
> public key is desirable.  We already need to assign one OID for the 
> signature validation (or key management technique).  
> Assigning a second OID 
> for use in the subject public key info to say that the key 
> can only be used 
> in a particular manner is only useful if the parameters that 
> are already 
> associated with the currently assigned OID do not support the 
> necessary 
> information.
> 
> Russ
> 
> >[JS] 7.  Section 3.2.  I would like to see a different OID used for a
> >signature value from that used to encode the public key.  
> This makes it
> >easier to process for encode/decode as there are not two 
> structures with
> >the same OID.
> >
> >[BK] The OID is not used to encode the public key directly, 
> but to encode an
> >AlgorithmID; the AlgorithmID is used to describe the public 
> key. So, the
> >AlgorithmID has two meanings, one for the signature, one for 
> the public key.
> >I agree this is potential problem, and am open to alternatives.
>

---

From: Russ Housley <[email-masked]>
Date: Thu, 06 Mar 2003 14:03:34 -0500

Jim:

In my proposal, the parameters are exactly the same.  So, the same table, 
with the same index, can be used.

Russ

---

From: "Jim Schaad" <[email-masked]>
Date: Thu, 6 Mar 2003 13:07:30 -0800

Russ,

Yes the parameters are the same, however the second structures are not
the same.  A signature value and the key do not have the same structure.
I also index these structures based on the OID value.

jim

> Sent: Thursday, March 06, 2003 11:04 AM
> To: [email-masked]; [email-masked]
> Cc: [email-masked]